/* eslint-disable @typescript-eslint/naming-convention */

import { EnumDbType } from "../../../db/model/EnumDbType";
import { GenericDbField } from "../../../db/model/GenericDbField";
import { GenericDbTable } from "../../../db/model/GenericDbTable";
import { AbstractPythonProcessor } from "../AbstractPythonProcessor";

export abstract class AbstractDjangoProcessor extends AbstractPythonProcessor {

  // All templates are expected in this sub-folder
  protected templateFolder?: string = "django";

  // django tables that we want to skip from process
  protected readonly DJANGO_TABLES = [
    "django_migrations",
    "sqlite_sequence",
    "auth_group_permissions",
    "auth_user_groups",
    "auth_user_user_permissions",
    "django_admin_log",
    "django_content_type",
    "auth_permission",
    "auth_group",
    "auth_user",
    "django_session",
  ];

  /**
   * Check if table name is not a Django reserved table
   * @param rTable : table
   * @returns true if it is not a Django reserved table, false otherwise
   */
  protected isNotDjangoTable(rTable: GenericDbTable): boolean {
    return this.DJANGO_TABLES.indexOf(rTable.tableName) < 0;
  }

  /**
   * Get Django Type from field type
   * @param rField : field
   * @returns Django Type
   */
  protected getDjangoModelsTypeByType(rField: GenericDbField) {
    let modelsTyp: string | undefined;
    if (rField?.type) {
      switch (rField?.type?.type) {
        case EnumDbType.long:
        case EnumDbType.int:
          modelsTyp = rField.isAutogenerated ? "Auto" : "BigInteger";
          break;
        case EnumDbType.float:
        case EnumDbType.double:
        case EnumDbType.numeric:
          modelsTyp = "Float";
          break;
        case EnumDbType.char:
        case EnumDbType.varchar:
        case EnumDbType.enum:
            modelsTyp = "Char";
          break;
        case EnumDbType.uuid:
          modelsTyp = "UUID";
          break;
        case EnumDbType.longtext:
          modelsTyp = "Text";
          break;
        case EnumDbType.date:
          modelsTyp = "Date";
          break;
        case EnumDbType.datetime:
        case EnumDbType.timestamp:
          modelsTyp = "DateTime";
          break;
        case EnumDbType.time:
          modelsTyp = "Time";
          break;
        case EnumDbType.interval:
          modelsTyp = "Duration";
          break;
        case EnumDbType.boolean:
          modelsTyp = "Boolean";
          break;
        case EnumDbType.blob:
          modelsTyp = "Binary";
          break;
        case EnumDbType.json:
          modelsTyp = "JSON";
          break;
        case EnumDbType.array:
          // Careful, we put Char but finally this will be embedded on a ArrayField @see getDjangoField() method
          modelsTyp = "Char";
          break;
        default:
          modelsTyp = undefined;
          break;
      }
    }
    return modelsTyp ? `${modelsTyp}Field` : "unknown";
  }

  /**
   * Get enum name from field when this is an enum type
   * @param rField : Field
   * @returns Field enum
   */
  protected getEnumNameFromField(rField: GenericDbField): string {
    let className = this.processClassNameFromTable(rField.fieldName ?? "");
    return `${className}Enum`;
  }
}
